﻿using ElectricLocomotive.DrawningObject;
using ElectricLocomotive.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ElectricLocomotive
{
    internal class DrawningLocomotiveEqutables : IEqualityComparer<DrawningLocomotive?>
    {
        public bool Equals(DrawningLocomotive? x, DrawningLocomotive? y)
        {
            if (x == null || x.EntityLocomotive == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityLocomotive == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityLocomotive.Speed != y.EntityLocomotive.Speed)
            {
                return false;
            }
            if (x.EntityLocomotive.Weight != y.EntityLocomotive.Weight)
            {
                return false;
            }
            if (x.EntityLocomotive.BodyColor != y.EntityLocomotive.BodyColor)
            {
                return false;
            }
            if (x is DrawningElectricLocomotive && y is DrawningElectricLocomotive)
            {
                if ((x.EntityLocomotive as EntityElectroLocomotive).AdditionalColor != (y.EntityLocomotive as EntityElectroLocomotive).AdditionalColor)
                {
                    return false;
                }
                if ((x.EntityLocomotive as EntityElectroLocomotive).Horns_1 != (y.EntityLocomotive as EntityElectroLocomotive).Horns_1)
                {
                    return false;
                }
                if ((x.EntityLocomotive as EntityElectroLocomotive).Horns_2 != (y.EntityLocomotive as EntityElectroLocomotive).Horns_2)
                {
                    return false;
                }
            }
            return true;
        }
        public int GetHashCode([DisallowNull] DrawningLocomotive obj)
        {
            return obj.GetHashCode();
        }
    }
}
