﻿

using ElectricLocomotive.DrawningObject;
using ElectricLocomotive.Entities;

namespace ElectricLocomotive
{
    internal class LocomotiveCompareByColor : IComparer<DrawningLocomotive?>
    {
        public int Compare(DrawningLocomotive? x, DrawningLocomotive? y)
        {
            if (x == null || x.EntityLocomotive == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityLocomotive == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.EntityLocomotive.BodyColor.Name != y.EntityLocomotive.BodyColor.Name)
            {
                return x.EntityLocomotive.BodyColor.Name.CompareTo(y.EntityLocomotive.BodyColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                if (x is DrawningLocomotive)
                    return -1;
                else
                    return 1;
            }
            if (x.GetType().Name == y.GetType().Name && x is DrawningLocomotive)
            {
                EntityElectroLocomotive entityX = (EntityElectroLocomotive)x.EntityLocomotive;
                EntityElectroLocomotive entityY = (EntityElectroLocomotive)y.EntityLocomotive;
                if (entityX.AdditionalColor.Name != entityY.AdditionalColor.Name)
                {
                    return entityX.AdditionalColor.Name.CompareTo(entityY.AdditionalColor.Name);
                }
            }
            var speedCompare =
                x.EntityLocomotive.Speed.CompareTo(y.EntityLocomotive.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityLocomotive.Weight.CompareTo(y.EntityLocomotive.Weight);
        }
    }
}
