﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ElectricLocomotive.DrawningObject;
using ProjectElectricLocomotive.DrawingObjects;

namespace ProjectElectricLocomotive.Generics
{
    internal class LocomotiveCompareByType : IComparer<DrawningLocomotive?>
    {
        public int Compare(DrawningLocomotive? x, DrawningLocomotive? y)
        {
            if (x == null || x.EntityLocomotive == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityLocomotive == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityLocomotive.Speed.CompareTo(y.EntityLocomotive.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityLocomotive.Weight.CompareTo(y.EntityLocomotive.Weight);
        }
    }
}
