﻿using ProjectElectricLocomotive.MovementStrategy;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ElectricLocomotive.MovementStrategy
{
    public class MoveToRightCorner : AbstractStrategy
    {
        protected override bool IsTargetDestinaion()
        {
            var objParams = GetObjectParameters;
            if (objParams == null) return false;

            return objParams.RightBorder >= FieldWidth - GetStep() && objParams.DownBorder >= FieldHeight - GetStep();
        }

        protected override void MoveToTarget()
        {
            var objParams = GetObjectParameters;
            if (objParams == null) return;

            if (objParams.RightBorder < FieldWidth - GetStep()) MoveRight();
            if (objParams.DownBorder < FieldHeight - GetStep()) MoveDown();

        }
    }
}
